#!/usr/local/bin/perl

require "Blowfish_PP.pm";

$max=2;

$size=$ENV{'CONTENT_LENGTH'};

if($size>1024*1024){
  exit;
}

binmode(STDIN);

while($size){
  $len=sysread(STDIN, $buf, $size);
  if($len==0){
    last;
  }
  $size=$size-$len;
  $data=$data.$buf;
}

$x=index($data,"\r\n");
$cut=substr($data,0,$x);
$cut="\r\n".$cut;

for($i=0;$i<$max;$i++){
  $x=index($data,"\r\n\r\n")+4;
  $filename[$i]=substr($data,0,$x);
  $filename[$i]=~s/\n//g;
  $filename[$i]=~s/.*filename="//;
  $filename[$i]=~s/".*//;
  $filename[$i]=~s/.*\\//g;
  $filename[$i]=~s".*/""g;
  $y=length($data);
  $data=substr($data,$x,$y-$x);
  $x=index($data,$cut);
  $y=length($data);
  $file[$i]=substr($data,0,$x);
  $data=substr($data,$x+2,$y-$x-2);
}

binmode(STDOUT);

print "Content-type:application/octet-stream\n";
print "Content-Disposition:attachment;filename=d_$filename[1]\n\n";

$key_in="12345678" . $file[0];
$change=new Crypt::Blowfish_PP($key_in);

@data_in=unpack("C*",$file[1]);

$loop=int(($#data_in+1)/8);
$data_out="";
for($i=0;$i<$loop;$i++){
  $data_block="";
  for($j=0;$j<8;$j++){
    $data_block=$data_block . pack("C",$data_in[$i*8+$j]);
  }
  $data_out=$data_out . $change->decrypt($data_block);
}

@data_max=unpack("C*",$data_out);

$len=$#data_max+1;
for($i=$#data_max;$i>=0;$i--){
  if($data_max[$i]==$data_max[$#data_max]){
    $len=$len-1;
  }else{
    last;
  }
}

for($i=0;$i<$len;$i++){
  print pack("C",$data_max[$i]);
}

exit;
